#!/usr/bin/env python
# Externe Taster fuer Pause, Resume, Cancel und Home Funktion     (kgolger 2022.06.08)
# https://www.elektronik-kompendium.de/sites/raspberry-pi/2110081.htm
import requests
import RPi.GPIO as GPIO
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
from time import sleep
pauseinputpin = 21
resumeinputpin = 20
cancelinputpin = 6
homeinputpin = 5
pauseoutputpin = 19
resumeoutputpin = 26
#
GPIO.setup(pauseinputpin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(resumeinputpin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(cancelinputpin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(homeinputpin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
#
GPIO.setup(pauseoutputpin, GPIO.OUT)
GPIO.setup(resumeoutputpin, GPIO.OUT)
#
GPIO.output(pauseoutputpin, GPIO.LOW)
GPIO.output(resumeoutputpin, GPIO.LOW)
#
while True:
#pause
    if GPIO.input(pauseinputpin) == False: # schwarzer Pause Taster offen
        GPIO.output(pauseoutputpin, GPIO.LOW)
    else:
        GPIO.output(pauseoutputpin, GPIO.HIGH) # schwarzer Pause Taster gschlossen
#resume
    if GPIO.input(resumeinputpin) == False: # gruener Resume Taster offen
        GPIO.output(resumeoutputpin, GPIO.LOW)
    else:
        GPIO.output(resumeoutputpin, GPIO.HIGH) # gruener Resume Taster geschlossen
#cancel
    if GPIO.input(cancelinputpin) == True: # roter Cancel Taster geschlossen
        json_data = {
            'commands': [
                'CANCEL_PRINT',
            ],
        }
        send = requests.post('http://192.168.0.15:7125/api/printer/command', json=json_data)
#home
    if GPIO.input(homeinputpin) == True: # greuner Home Taster geschlossen
        json_data = {
            'commands': [
                'HOME',
            ],
        }
        send = requests.post('http://192.168.0.15:7125/api/printer/command',json=json_data)
#
sleep(0.5)
